"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsSqlInit = void 0;
var sql = require("mssql");
var log4js = require("log4js");
var mssql_config_1 = require("../config/mssql.config");
var auth_mssql_1 = require("./mssql/auth.mssql");
var batch_mssql_1 = require("./mssql/batch.mssql");
var batch_error_mssql_1 = require("./mssql/batch-error.mssql");
var batch_schedule_mssql_1 = require("./mssql/batch-schedule.mssql");
var custom_field_mssql_1 = require("./mssql/custom-field.mssql");
var diarization_mssql_1 = require("./mssql/diarization.mssql");
var sentiment_mssql_1 = require("./mssql/sentiment.mssql");
var dictionary_mssql_1 = require("./mssql/dictionary.mssql");
var domain_mssql_1 = require("./mssql/domain.mssql");
var entity_mssql_1 = require("./mssql/entity.mssql");
var evaluation_tipification_mssql_1 = require("./mssql/evaluation-tipification.mssql");
var tipification_mssql_1 = require("./mssql/tipification.mssql");
var vcc_mssql_1 = require("./mssql/vcc.mssql");
var vcc_license_mssql_1 = require("./mssql/vcc-license.mssql");
var home_mssql_1 = require("./mssql/home.mssql");
var notification_mssql_1 = require("./mssql/notification.mssql");
var profile_image_mssql_1 = require("./mssql/profile-image.mssql");
var report_mssql_1 = require("./mssql/report.mssql");
var role_mssql_1 = require("./mssql/role.mssql");
var user_mssql_1 = require("./mssql/user.mssql");
var api_user_mssql_1 = require("./mssql/api-user.mssql");
var azure_subscription_mssql_1 = require("./mssql/azure-subscription.mssql");
var client_mssql_1 = require("./mssql/client.mssql");
var process_mssql_1 = require("./mssql/process.mssql");
var exception_mssql_1 = require("./mssql/exception.mssql");
var environment_mssql_1 = require("./mssql/environment.mssql");
var allegro_mssql_1 = require("./mssql/allegro.mssql");
var audio_mssql_1 = require("./mssql/audio.mssql");
var idatha_mssql_1 = require("./mssql/idatha.mssql");
var feeling_mssql_1 = require("./mssql/feeling.mssql");
var category_mssql_1 = require("./mssql/category.mssql");
var neuro_linguistic_programming_mssql_1 = require("./mssql/neuro-linguistic-programming.mssql");
var template_mssql_1 = require("./mssql/template.mssql");
var custom_template_mssql_1 = require("./mssql/custom-template.mssql");
var generic_template_mssql_1 = require("./mssql/generic-template.mssql");
var generic_query_mssql_1 = require("./mssql/generic-query.mssql");
var nlu_mssql_1 = require("./mssql/nlu.mssql");
var intent_mssql_1 = require("./mssql/intent.mssql");
var utterance_mssql_1 = require("./mssql/utterance.mssql");
var tag_mssql_1 = require("./mssql/tag.mssql");
var study_mssql_1 = require("./mssql/study.mssql");
var word_blacklist_mssql_1 = require("./mssql/word-blacklist.mssql");
var integration_mssql_1 = require("./mssql/integration.mssql");
var campaign_fulfillment_mssql_1 = require("./mssql/campaign-fulfillment.mssql");
var average_group_rating_mssql_1 = require("./mssql/average-group-rating.mssql");
var average_group_rating_norm_mssql_1 = require("./mssql/average-group-rating-norm.mssql");
var top_best_agents_mssql_1 = require("./mssql/top-best-agents.mssql");
var top_worst_agents_mssql_1 = require("./mssql/top-worst-agents.mssql");
var ability_mssql_1 = require("./mssql/ability.mssql");
var subgroup_mssql_1 = require("./mssql/subgroup.mssql");
var group_mssql_1 = require("./mssql/group.mssql");
var evaluation_format_mssql_1 = require("./mssql/evaluation-format.mssql");
var campain_mssql_1 = require("./mssql/campain.mssql");
var workgroup_mssql_1 = require("./mssql/workgroup.mssql");
var attentionlevel_mssql_1 = require("./mssql/attentionlevel.mssql");
var interaction_mssql_1 = require("./mssql/interaction.mssql");
var evaluation_plan_mssql_1 = require("./mssql/evaluation-plan.mssql");
var interaction_type_mssql_1 = require("./mssql/interaction-type.mssql");
var evaluation_mssql_1 = require("./mssql/evaluation.mssql");
var evaluation_review_mssql_1 = require("./mssql/evaluation-review.mssql");
var auditor_mssql_1 = require("./mssql/auditor.mssql");
var agent_mssql_1 = require("./mssql/agent.mssql");
var interactions_by_type_mssql_1 = require("./mssql/interactions-by-type.mssql");
var supervisor_mssql_1 = require("./mssql/supervisor.mssql");
var tenant_vcc_mssql_1 = require("./mssql/tenant-vcc.mssql");
var version_mssql_1 = require("./mssql/version.mssql");
var async_interaction_mssql_1 = require("./mssql/async-interaction.mssql");
var disposition_code_mssql_1 = require("./mssql/disposition-code.mssql");
var logger = log4js.getLogger('Sql');
function MsSqlInit(app) {
    return new Promise(function (resolve, reject) {
        logger.info('Iniciando conexión a base de datos \'' + mssql_config_1.MSSQL_CONFIG.server + '\'');
        console.log('Iniciando conexión a base de datos \'' + mssql_config_1.MSSQL_CONFIG.server + '\'');
        var sqlConn = new sql.Connection(mssql_config_1.MSSQL_CONFIG, function (err) {
            if (err) {
                var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'SERVER_ERROR_UNKNOWN_MESSAGE');
                logger.error('No se pudo establecer conexion a base de datos: ' + errMsg);
                console.error('No se pudo establecer conexion a base de datos: ' + errMsg);
                reject(err);
            }
            else {
                logger.info('Conexión a base de datos establecida');
                console.log('Conexión a base de datos establecida');
                resolve(true);
            }
        });
        app.set('sqlConn', sqlConn);
        auth_mssql_1.AuthMSSql(app);
        batch_mssql_1.BatchMSSql(app);
        batch_error_mssql_1.BatchErrorMSSql(app);
        batch_schedule_mssql_1.BatchScheduleMSSql(app);
        custom_field_mssql_1.CustomFieldMSSql(app);
        diarization_mssql_1.DiarizationMSSql(app);
        sentiment_mssql_1.SentimentMSSql(app);
        dictionary_mssql_1.DictionaryMSSql(app);
        domain_mssql_1.DomainMSSql(app);
        entity_mssql_1.EntityMSSql(app),
            evaluation_tipification_mssql_1.EvaluationTipificationMSSql(app);
        tipification_mssql_1.TipificationMSSql(app),
            vcc_mssql_1.VCCMSSql(app);
        vcc_license_mssql_1.VCCLicenseMSSql(app);
        home_mssql_1.HomeMSSql(app);
        notification_mssql_1.NotificationMSSql(app);
        profile_image_mssql_1.ProfileImageMSSql(app);
        report_mssql_1.ReportMSSql(app);
        role_mssql_1.RoleMSSql(app);
        user_mssql_1.UserMSSql(app);
        api_user_mssql_1.ApiUserMSSql(app);
        azure_subscription_mssql_1.AzureSubscriptionMSSql(app);
        client_mssql_1.ClientMSSql(app);
        process_mssql_1.ProcessMSSql(app);
        exception_mssql_1.ExceptionMSSql(app);
        environment_mssql_1.EnvironmentMSSql(app);
        allegro_mssql_1.AllegroMSSql(app);
        audio_mssql_1.AudiosMSSql(app);
        idatha_mssql_1.IdathaMSSql(app);
        feeling_mssql_1.FeelingMSSql(app);
        category_mssql_1.CategoryMSSql(app);
        neuro_linguistic_programming_mssql_1.NeuroLinguisticProgrammingMSSql(app);
        template_mssql_1.TemplateMSSql(app);
        custom_template_mssql_1.CustomTemplateMSSql(app);
        generic_template_mssql_1.GenericTemplateMSSql(app);
        generic_query_mssql_1.GenericQueryMSSql(app);
        nlu_mssql_1.NLUMSSql(app);
        intent_mssql_1.IntentMSSql(app);
        utterance_mssql_1.UtteranceMSSql(app);
        tag_mssql_1.TagMSSql(app);
        study_mssql_1.StudyMSSql(app);
        word_blacklist_mssql_1.WordBlacklistMSSql(app);
        integration_mssql_1.IntegrationMSSql(app);
        campaign_fulfillment_mssql_1.CampaignFulfillmentMssql(app);
        average_group_rating_mssql_1.AverageGroupRatingMssql(app);
        average_group_rating_norm_mssql_1.AverageGroupRatingNormMssql(app);
        top_best_agents_mssql_1.TopBestAgentsMssql(app);
        top_worst_agents_mssql_1.TopWorstAgentsMssql(app);
        interactions_by_type_mssql_1.InteractionsByTypeMSSql(app);
        ability_mssql_1.AbilityMSSql(app);
        subgroup_mssql_1.SubgroupMSSql(app);
        group_mssql_1.GroupMSSql(app);
        evaluation_format_mssql_1.EvaluationFormatMSSql(app);
        campain_mssql_1.CampainMSSql(app);
        disposition_code_mssql_1.DispositionCodeMSSql(app);
        workgroup_mssql_1.WorkGroupMSSql(app);
        attentionlevel_mssql_1.AttentionLevelMSSql(app);
        interaction_mssql_1.InteractionMSSql(app);
        evaluation_plan_mssql_1.EvaluationPlanMSSql(app);
        interaction_type_mssql_1.InteractionTypeMSSql(app);
        evaluation_mssql_1.EvaluationMSSql(app);
        evaluation_review_mssql_1.EvaluationReviewMSSql(app);
        auditor_mssql_1.AuditorMSSql(app);
        agent_mssql_1.AgentMSSql(app);
        version_mssql_1.VersionMSSql(app);
        api_user_mssql_1.ApiUserMSSql(app);
        supervisor_mssql_1.SupervisorMSSql(app);
        tenant_vcc_mssql_1.TenantVCCMSSql(app);
        async_interaction_mssql_1.AsyncInteractionMSSql(app);
    });
}
exports.MsSqlInit = MsSqlInit;
