"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InteractionCognitiveResult = exports.InteractionQueryResult = exports.AsyncInteractionView = exports.AsyncInteraction = exports.ResultsCodesFilters = exports.InteractionView = exports.InteractionSelect = exports.InteractionSearch = exports.LevelTag = exports.Level = exports.InteractionTag = exports.InteractionAllData = exports.MultimediaPart = exports.MultimediaPartGroup = exports.AuditorInboxInteraction = exports.Interaction = void 0;
var Interaction = (function () {
    function Interaction(id, idCampaign, idAgent, dateIni, dateFin, interactionTime, interactionType, dispositionCode, address, origin, evaluated, descriptionCampaign, descriptionAgent, idEvaluationPlan, descriptionEvaluationPlan, dateFinEvaluationPlan, qualification, descriptionAuditor, idAuditorEvaluationPlan, textAvailable, interactionText, completed) {
        if (evaluated === void 0) { evaluated = false; }
        if (descriptionCampaign === void 0) { descriptionCampaign = null; }
        if (descriptionAgent === void 0) { descriptionAgent = null; }
        if (idEvaluationPlan === void 0) { idEvaluationPlan = null; }
        if (descriptionEvaluationPlan === void 0) { descriptionEvaluationPlan = null; }
        if (dateFinEvaluationPlan === void 0) { dateFinEvaluationPlan = null; }
        if (qualification === void 0) { qualification = null; }
        if (descriptionAuditor === void 0) { descriptionAuditor = null; }
        if (idAuditorEvaluationPlan === void 0) { idAuditorEvaluationPlan = null; }
        if (textAvailable === void 0) { textAvailable = false; }
        if (interactionText === void 0) { interactionText = null; }
        if (completed === void 0) { completed = null; }
        this.id = id;
        this.idCampaign = idCampaign;
        this.idAgent = idAgent;
        this.dateIni = dateIni;
        this.dateFin = dateFin;
        this.interactionTime = interactionTime;
        this.interactionType = interactionType;
        this.dispositionCode = dispositionCode;
        this.address = address;
        this.origin = origin;
        this.evaluated = evaluated;
        this.descriptionCampaign = descriptionCampaign;
        this.descriptionAgent = descriptionAgent;
        this.idEvaluationPlan = idEvaluationPlan;
        this.descriptionEvaluationPlan = descriptionEvaluationPlan;
        this.dateFinEvaluationPlan = dateFinEvaluationPlan;
        this.qualification = qualification;
        this.descriptionAuditor = descriptionAuditor;
        this.idAuditorEvaluationPlan = idAuditorEvaluationPlan;
        this.textAvailable = textAvailable;
        this.interactionText = interactionText;
        this.completed = completed;
        this.selected = false;
        this.interactionPartGroups = [];
        this.hasVideo = false;
        this.number = null;
        this.agentName = '';
        this.vcc = '';
    }
    return Interaction;
}());
exports.Interaction = Interaction;
var AuditorInboxInteraction = (function () {
    function AuditorInboxInteraction() {
        this.address = null;
        this.agentName = null;
        this.auditorName = null;
        this.dateFin = null;
        this.descriptionAgent = null;
        this.descriptionCampaign = null;
        this.descriptionEvaluationPlan = null;
        this.dispositionCode = null;
        this.idAuditor = null;
        this.idEvaluationPlan = null;
        this.interactionTime = null;
        this.interactionType = null;
        this.id = null;
        this.origin = null;
        this.status = false;
        this.evaluationPlanModality = null;
        this.evaluationPlanEvaluationMode = null;
        this.isEvaluationBeingEvaluated = false;
        this.isInteractionBeingEvaluated = false;
    }
    return AuditorInboxInteraction;
}());
exports.AuditorInboxInteraction = AuditorInboxInteraction;
var MultimediaPartGroup = (function () {
    function MultimediaPartGroup(agentId, parts) {
        if (parts === void 0) { parts = []; }
        this.agentId = agentId;
        this.parts = parts;
    }
    return MultimediaPartGroup;
}());
exports.MultimediaPartGroup = MultimediaPartGroup;
var MultimediaPart = (function () {
    function MultimediaPart(section, part, partURL, agentId, format) {
        this.section = section;
        this.part = part;
        this.partURL = partURL;
        this.agentId = agentId;
        this.format = format;
    }
    return MultimediaPart;
}());
exports.MultimediaPart = MultimediaPart;
var InteractionAllData = (function () {
    function InteractionAllData(id, idCampaign, descriptionCampaign, idAgent, descriptionAgent, dateIni, dateFin, interactionTime, evaluated, interactionType, dispositionCode, address, origin, idEvaluationPlan, descriptionEvaluationPlan, dateFinEvaluationPlan, qualification, descriptionAuditor, descriptionTag, idTag, descriptionWorkGroup, idWorkGroup, descriptionAttentionLevel, idAttentionLevel, textAvailable, interactionText) {
        this.id = id;
        this.idCampaign = idCampaign;
        this.descriptionCampaign = descriptionCampaign;
        this.idAgent = idAgent;
        this.descriptionAgent = descriptionAgent;
        this.dateIni = dateIni;
        this.dateFin = dateFin;
        this.interactionTime = interactionTime;
        this.evaluated = evaluated;
        this.interactionType = interactionType;
        this.dispositionCode = dispositionCode;
        this.address = address;
        this.origin = origin;
        this.idEvaluationPlan = idEvaluationPlan;
        this.descriptionEvaluationPlan = descriptionEvaluationPlan;
        this.dateFinEvaluationPlan = dateFinEvaluationPlan;
        this.qualification = qualification;
        this.descriptionAuditor = descriptionAuditor;
        this.descriptionTag = descriptionTag;
        this.idTag = idTag;
        this.descriptionWorkGroup = descriptionWorkGroup;
        this.idWorkGroup = idWorkGroup;
        this.descriptionAttentionLevel = descriptionAttentionLevel;
        this.idAttentionLevel = idAttentionLevel;
        this.textAvailable = textAvailable;
        this.interactionText = interactionText;
    }
    return InteractionAllData;
}());
exports.InteractionAllData = InteractionAllData;
var InteractionTag = (function () {
    function InteractionTag(idInteraction, idTag, descriptionTag) {
        this.idInteraction = idInteraction;
        this.idTag = idTag;
        this.descriptionTag = descriptionTag;
        this.selected = false;
    }
    return InteractionTag;
}());
exports.InteractionTag = InteractionTag;
var Level = (function () {
    function Level(id, idInteraction, urlStreaming) {
        this.id = id;
        this.idInteraction = idInteraction;
        this.urlStreaming = urlStreaming;
        this.selected = false;
    }
    return Level;
}());
exports.Level = Level;
var LevelTag = (function () {
    function LevelTag(idLevel, idInteraction, idTag, descriptionTag) {
        this.idLevel = idLevel;
        this.idInteraction = idInteraction;
        this.idTag = idTag;
        this.descriptionTag = descriptionTag;
        this.selected = false;
    }
    return LevelTag;
}());
exports.LevelTag = LevelTag;
var InteractionSearch = (function () {
    function InteractionSearch() {
        this.evaluationStatus = [];
        this.interactionIds = [];
        this.withSectionPart = false;
        this.efectivityMode = false;
    }
    return InteractionSearch;
}());
exports.InteractionSearch = InteractionSearch;
var InteractionSelect = (function () {
    function InteractionSelect() {
    }
    return InteractionSelect;
}());
exports.InteractionSelect = InteractionSelect;
var InteractionView = (function () {
    function InteractionView() {
    }
    return InteractionView;
}());
exports.InteractionView = InteractionView;
var ResultsCodesFilters = (function () {
    function ResultsCodesFilters() {
    }
    return ResultsCodesFilters;
}());
exports.ResultsCodesFilters = ResultsCodesFilters;
var AsyncInteraction = (function () {
    function AsyncInteraction() {
        this.category1 = this.GetCategory(0);
        this.category2 = this.GetCategory(1);
        this.category3 = this.GetCategory(2);
        this.category4 = this.GetCategory(3);
        this.category5 = this.GetCategory(4);
    }
    AsyncInteraction.prototype.GetCategory = function (index) {
        var category = null;
        if (this.dispositionTreePath) {
            var categoriesArr = this.dispositionTreePath.split('/');
            if (categoriesArr.length > index)
                category = categoriesArr[index];
        }
        return category;
    };
    return AsyncInteraction;
}());
exports.AsyncInteraction = AsyncInteraction;
var AsyncInteractionView = (function () {
    function AsyncInteractionView() {
    }
    return AsyncInteractionView;
}());
exports.AsyncInteractionView = AsyncInteractionView;
var InteractionQueryResult = (function () {
    function InteractionQueryResult() {
        this.interactionId = null;
        this.section = null;
        this.part = null;
        this.interactionType = null;
        this.transactionType = null;
        this.transactionId = null;
        this.transactionName = null;
        this.analysisType = null;
        this.queryId = null;
        this.queryName = null;
        this.queryValue = null;
        this.queryData = null;
        this.matches = null;
        this.details = null;
    }
    return InteractionQueryResult;
}());
exports.InteractionQueryResult = InteractionQueryResult;
var InteractionCognitiveResult = (function () {
    function InteractionCognitiveResult() {
        this.interactionId = null;
        this.section = null;
        this.part = null;
        this.interactionType = null;
        this.vcc = null;
        this.processResultId = null;
        this.typeProcessResultId = null;
    }
    return InteractionCognitiveResult;
}());
exports.InteractionCognitiveResult = InteractionCognitiveResult;
