"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IOService = void 0;
var log4js = require("log4js");
var io_shared_1 = require("../io/io.shared");
var promises_shared_1 = require("../shared/promises.shared");
var logger = log4js.getLogger('IO');
function IOService(app) {
    app.post('/io/send-events', function (req, res) {
        var events = req.body || [];
        promises_shared_1.DummyPromise().then(function (_) {
            var promises = [];
            for (var _i = 0, events_1 = events; _i < events_1.length; _i++) {
                var e = events_1[_i];
                switch (e.type) {
                    case 1:
                        promises.push(io_shared_1.SendEventToUser(e.event, e.data, e.vcc, e.userId));
                        break;
                    case 2:
                        promises.push(io_shared_1.SendEventToAllUsersVcc(e.event, e.data, e.vcc));
                        break;
                    default:
                        promises.push(io_shared_1.BroadcastEvent(e.event, e.data));
                        break;
                }
            }
            return Promise.all(promises);
        }).then(function (results) {
            res.send({
                status: !results.includes(false),
            });
        }).catch(function (err) {
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'Unknow error');
            logger.error('[IOService::send-events]:', errorMsg);
            res.json({ status: false, error: errorMsg });
        });
    });
}
exports.IOService = IOService;
