"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var logger_config_1 = require("../config/logger.config");
var log4js = require("log4js");
log4js.configure(logger_config_1.LOGGER_CONFIG);
var logger = log4js.getLogger('Task');
var findProcess = require("../shared/manager-process");
var schedule_task_1 = require("./schedule.task");
var listFilter;
findProcess.FindProcess('node')
    .then(function (list) {
    var arrayPromise = [];
    var onProgress = false;
    var ubuntuNodeProcess = { name: 'sh', cmd: '/bin/sh -c node ' };
    var windowsNodeProcess = { name: 'node.exe', cmd: 'node  ' };
    listFilter = list.filter(function (element) {
        onProgress = ((element.name === ubuntuNodeProcess.name || element.name === windowsNodeProcess.name)
            && (__filename.indexOf(element.cmd.replace(windowsNodeProcess.cmd, '')) > -1 || __filename.indexOf(element.cmd.replace(ubuntuNodeProcess.cmd, '')) > -1)) ? true : false;
        if (onProgress && element && element.time > 7200) {
            logger.info('[FindProcess] DELETED', element.id, element);
            arrayPromise.push(findProcess.KillTask(element.pid));
        }
        return onProgress;
    });
    logger.info('[FindProcess] total Task on progress', (listFilter && listFilter.length ? listFilter.length : 0));
    return Promise.all(arrayPromise);
}).then(function (result) {
    if (listFilter && (listFilter.length === 0 || listFilter.length === 1)) {
        logger.info('[FindProcess] RUN');
        return schedule_task_1.InitTask();
    }
    else {
        logger.info('[FindProcess] CANCEL EXEC');
    }
    return Promise.resolve(true);
}).catch(function (err) {
    logger.error('[FindProcess] getting error:', err);
    return Promise.resolve(false);
});
